package com.lc;


import com.lc.Runner.SpringJunitRunner;
import com.lc.redisPool.IRedisPool;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import redis.clients.jedis.Jedis;

import java.util.concurrent.CountDownLatch;

/**
 *
 */
@RunWith(SpringJunitRunner.class)
@ContextConfiguration(locations={"classpath:spring-servlet.xml"})
public class RedisPoolTest {

    @Autowired
    private IRedisPool pool;
    private final static int THREAD_NUM=10;
    private final CountDownLatch cdl=new CountDownLatch(THREAD_NUM);//栅栏
//发令枪 等待一定的时间点  栅栏 等待一定的数量


    public void test() throws Exception {
        //初始化连接池
        pool.init(9,10000);
        //模拟并发场景对Redis进行操作，分析连接池中是否只创建了指定的连接数

        for (int i = 0; i < THREAD_NUM; i++) {
            new Thread(new Runnable() {
                @Override
                public void run() {
                    try {
                        cdl.await();//等待 等待一个唤醒指令，所有等待的线程同时执行
                    } catch (InterruptedException e) {
                        throw new RuntimeException(e);
                    }
                    Jedis jedis=null;
                    try {
                        jedis=pool.getResource();
                        jedis.incr("poolTest.incr");
                    } catch (Exception e) {
                        throw new RuntimeException(e);
                    }finally {
                        pool.release(jedis);
                    }

                }
            }).start();
            cdl.countDown();//计数 当等于0时唤醒所有的等待线程
        }
        Thread.sleep(2000);
    }
}
