package com.lc.redisPool;

import redis.clients.jedis.Jedis;

/**
 * 定义一个连接池的接口
 */
public interface IRedisPool {

    /**
     * 连接池初始化
     * @param maxTotal 最大连接数
     * @param maxWaiMillis 最长连接时间
     */
    public void init(int maxTotal,long maxWaiMillis);

    /**
     * 获取连接
     * @return
     * @throws Exception
     */
    public Jedis getResource() throws  Exception;

    /**
     * 获取连接
     * @param jedis
     */
    public void release(Jedis jedis);
}
